/***************************************************************************
 *   Copyright (C) 2004 by Olivier Galizzi                                 *
 *   galizzi@stalactite                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Root.hpp"

Root::Root() : Serializable()
{
};

Root::~Root()
{
}


void Root::init()
{
	v2  = Vector2r(Mathr::unitRandom(),Mathr::unitRandom());
	v3  = Vector3r(Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom());
	v4  = Vector4r(Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom());
	m2  = Matrix2r(Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom());
	m3  = Matrix3r(Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom());
	m4  = Matrix4r(Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom());
	q   = Quaternionr(Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom());
	q.normalize();

	Quaternionr tmpQ(Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom());
	Vector3r tmpV(Mathr::unitRandom(),Mathr::unitRandom(),Mathr::unitRandom());
	se3 = Se3r(tmpV,tmpQ);

	i  = (int)(Mathf::unitRandom()*200);

	f  = Mathf::unitRandom();

	d  = Mathd::unitRandom();

	c  = 'E';

	ul = (unsigned long)(Mathf::unitRandom()*200);

	vi.push_back((int)(Mathf::unitRandom()*200));
	vi.push_back((int)(Mathf::unitRandom()*200));
	vi.push_back((int)(Mathf::unitRandom()*200));
	vi.push_back((int)(Mathf::unitRandom()*200));
// 	vi.push_back((int)(Mathf::unitRandom()*200));

	A a1;
	va.push_back(a1);
	A a2;
 	va.push_back(a2);
	A a3;
 	va.push_back(a3);

	vb.push_back(b);
	vb.push_back(b);
	vb.push_back(b);
	vb.push_back(b);

	vvb.push_back(vb);
	vvb.push_back(vb);
	vvb.push_back(vb);

	vv3.push_back(v3);
	vv3.push_back(v3);
	vv3.push_back(v3);

	set<int> vi2,vi3,vi4;
	vi2.insert(201);
	vi2.insert(202);
	vi2.insert(203);
	vi3.insert(301);
	vi3.insert(302);
	vi4.insert(401);
	vi4.insert(402);
	vi4.insert(403);
	vi4.insert(404);
/*
	vector<int> vi2,vi3,vi4;
	vi2.push_back(201);
	vi2.push_back(202);
	vi2.push_back(203);
	vi3.push_back(301);
	vi3.push_back(302);
	vi4.push_back(401);
	vi4.push_back(402);
	vi4.push_back(403);
	vi4.push_back(404);
*/
	si.insert(1);
	si.insert(3);
	si.insert(22);
	si.insert(10);



	vvi.push_back(si);
//	vvi.push_back(vi);
	vvi.push_back(vi2);
	vvi.push_back(vi3);
	vvi.push_back(vi4);

	deque<set<int> > vvi2;
	vvi2.resize(2);
	vvvi.push_back(vvi);
	vvvi.push_back(vvi2);
	vvvi.push_back(vvi);
	vvvi.push_back(vvi);
	bo = false;

	s = "hello";

	ptr_ac_ac=shared_ptr<AC>(new AC); // NOT EXECUTED for deserialization
	ptr_a_ac=shared_ptr<A>(new AC);   // but WHY it works for serialization ??????????????????
	ptr_a_acd = shared_ptr<A>(new ACD);

	ptr_b=shared_ptr<B>(new B);
	ptr_i=shared_ptr<int>(new int((int)(Mathd::unitRandom()*200)));
	ptr_v3=shared_ptr<Vector3r>(new Vector3r);

	vpv3.push_back(shared_ptr<Vector3r>(new Vector3r));
	vpv3.push_back(shared_ptr<Vector3r>(new Vector3r));
	vpv3.push_back(shared_ptr<Vector3r>(new Vector3r));
	vpv3.push_back(shared_ptr<Vector3r>(new Vector3r));
	vpv3.push_back(shared_ptr<Vector3r>(new Vector3r));

	vpi.push_back(shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))));
	vpi.push_back(shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))));
	vpi.push_back(shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))));
	vpi.push_back(shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))));

	ptr_ptr_i = shared_ptr<shared_ptr<int> >(new shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))));

	ptr_ptr_v3 = shared_ptr<shared_ptr<Vector3r> >(new shared_ptr<Vector3r>(new Vector3r));

	ptr_v_v3 = shared_ptr<deque<Vector3r> >(new deque<Vector3r>);
	ptr_v_v3->push_back(Vector3r());
	ptr_v_v3->push_back(Vector3r());
	ptr_v_v3->push_back(Vector3r());
	ptr_v_v3->push_back(Vector3r());

	ptr_v_i = shared_ptr<deque<int> >(new deque<int>);
	ptr_v_i->push_back((int)(Mathd::unitRandom()*200));
	ptr_v_i->push_back((int)(Mathd::unitRandom()*200));
	ptr_v_i->push_back((int)(Mathd::unitRandom()*200));
	ptr_v_i->push_back((int)(Mathd::unitRandom()*200));

	vpppi.push_back(shared_ptr<shared_ptr<shared_ptr<int> > >(new shared_ptr<shared_ptr<int> >(new shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))))));
	vpppi.push_back(shared_ptr<shared_ptr<shared_ptr<int> > >(new shared_ptr<shared_ptr<int> >(new shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))))));
	vpppi.push_back(shared_ptr<shared_ptr<shared_ptr<int> > >(new shared_ptr<shared_ptr<int> >(new shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))))));
	vpppi.push_back(shared_ptr<shared_ptr<shared_ptr<int> > >(new shared_ptr<shared_ptr<int> >(new shared_ptr<int>(new int((int)(Mathd::unitRandom()*200))))));

	pppi = shared_ptr<shared_ptr<shared_ptr<int> > >(new shared_ptr<shared_ptr<int> >(new shared_ptr<int>(new int((int)(Mathd::unitRandom()*200)))));

	li.push_back((int)(Mathd::unitRandom()*200));
	li.push_back((int)(Mathd::unitRandom()*200));
	li.push_back((int)(Mathd::unitRandom()*200));
	li.push_back((int)(Mathd::unitRandom()*200));
	li.push_back((int)(Mathd::unitRandom()*200));
	li.push_back((int)(Mathd::unitRandom()*200));
	li.push_back((int)(Mathd::unitRandom()*200));

	lf.push_back(Mathd::unitRandom());
	lf.push_back(Mathd::unitRandom());
	lf.push_back(Mathd::unitRandom());
	lf.push_back(Mathd::unitRandom());
	lf.push_back(Mathd::unitRandom());
	lf.push_back(Mathd::unitRandom());
	lf.push_back(Mathd::unitRandom());

	v_ptr_a.push_back(shared_ptr<A>(new AC));
	v_ptr_a.push_back(shared_ptr<A>(new ACD));
	v_ptr_a.push_back(shared_ptr<A>(new A));
	v_ptr_a.push_back(shared_ptr<A>(new ACD));

	ptr_bc = shared_ptr<BC>(new BC);
	ptr_b_bc = shared_ptr<B>(new BC);

	vpb.push_back(shared_ptr<B>(new B));
	vpb.push_back(shared_ptr<B>(new BC));
	vpb.push_back(shared_ptr<B>(new BC));
	vpb.push_back(shared_ptr<B>(new B));

	dynA = shared_dynamic_cast<A>(ClassFactory::instance().createShared("DynA"));
	vdynA.push_back(shared_dynamic_cast<A>(ClassFactory::instance().createShared("DynAB")));
	vdynA.push_back(shared_dynamic_cast<A>(ClassFactory::instance().createShared("DynA")));
	vdynA.push_back(shared_dynamic_cast<A>(ClassFactory::instance().createShared("DynABC")));
	vdynA.push_back(shared_dynamic_cast<A>(ClassFactory::instance().createShared("DynAB")));


	small_pair.first	= 100;
	small_pair.second	= 123456789.123456789;

	pair_int_A.first	= 111;
	pair_int_A.second	= a;

	pair_B_longdouble.first	= b;
	pair_B_longdouble.second= 123999123.999991323;

	pair_B_A.first		= b;
	pair_B_A.second		= a;

	pair_B_pA.first		= b;
	pair_B_pA.second	= ptr_a_acd;

	pair_pA_vdynA.first	= ptr_a_acd;
	pair_pA_vdynA.second	= vdynA;

	pair_pA_vvvi.first	= ptr_a_acd;
	pair_pA_vvvi.second	= vvvi;

	v_pair_int_pA.clear();

	pair< int, shared_ptr<A> > pisA;
	pisA.first 		= 10;
	pisA.second		= ptr_a_ac;
	v_pair_int_pA.push_back(pisA);
	pisA.first 		= 22;
	pisA.second 		= ptr_a_acd;
	v_pair_int_pA.push_back(pisA);
	pisA.first 		= 52;
	pisA.second 		= v_ptr_a[0];
	v_pair_int_pA.push_back(pisA);
	pisA.first 		= -9901;
	pisA.second 		= dynA;
	v_pair_int_pA.push_back(pisA);
	pisA.first 		= 42;
	pisA.second 		= vdynA[0];
	v_pair_int_pA.push_back(pisA);



	tuple_int.get<0>() 	= 989;
	tuple_B.get<0>() 	= b;
	tuple_pA.get<0>() 	= dynA;


	tuple_pA_vdynA		= pair_pA_vdynA;
	tuple_pA_vvvi		= pair_pA_vvvi;

	tuple_int_pA_int.get<0>()	= 1000;
	tuple_int_pA_int.get<1>()	= dynA;
	tuple_int_pA_int.get<2>()	= 2002;


	tuple_int_pA_pB_B.get<0>()	= 999;
	tuple_int_pA_pB_B.get<1>()	= dynA;
	tuple_int_pA_pB_B.get<2>()	= ptr_b_bc;
	tuple_int_pA_pB_B.get<3>()	= b;

	tuple_funds.get<0>()		= 99;
	tuple_funds.get<1>()		= 1002;
	tuple_funds.get<2>()		= 3.14;
	tuple_funds.get<3>()		= 1234.423423;
	tuple_funds.get<4>()		= false;

	tuple_check.get<0>()		= 99;
	tuple_check.get<1>()		= 1002;
	tuple_check.get<2>()		= 3.14;
	tuple_check.get<3>()		= ptr_b_bc;
	tuple_check.get<4>()		= false;


	bodies.clear();
	bodies[10] = dynA;
	bodies[11] = ptr_a_ac;
	bodies[22] = ptr_a_acd;
	bodies[-42] = v_ptr_a[0];
	bodies[71] = vdynA[0];
	bodies[31] = dynA;

	bodies2.clear();
	bodies2[10] = dynA;
	bodies2[11] = ptr_a_ac;
	bodies2[22] = ptr_a_acd;
	bodies2[-42] = v_ptr_a[0];
	bodies2[71] = vdynA[0];
	bodies2[31] = dynA;


//////////////////////////////////////////
/// Insertion - filling the containers
//////////////////////////////////////////
  	ivs=shared_ptr<InteractionContainer>(new InteractionVecSet);
	ihm=shared_ptr<InteractionContainer>(new InteractionHashMap);
//	ihm2=shared_ptr<InteractionContainer>(new InteractionHashMap2);

	int nbInsertions = 10;
	shared_ptr<Interaction> interaction(new Interaction(0,0));

	ivs->clear();

        srand(10);
	for(int i=0;i<nbInsertions;i++)
	{
		interaction = shared_ptr<Interaction>(new Interaction((int)(Mathf::unitRandom()*200),(int)(Mathf::unitRandom()*200)));
		ivs->insert(interaction);
		cout << "inserted interaction Vector of Set: " << interaction->getId1() << " " << interaction->getId2() << endl;
	}

	srand(10);
	for(int i=0;i<nbInsertions;i++)
	{
		interaction = shared_ptr<Interaction>(new Interaction((int)(Mathf::unitRandom()*200),(int)(Mathf::unitRandom()*200)));
		ihm->insert(interaction);
		cout << "inserted interaction Hash Map     : " << interaction->getId1() << " " << interaction->getId2() << endl;
	}

//	srand(10);
//	for(int i=0;i<nbInsertions;i++)
//	{
//		interaction = shared_ptr<Interaction>(new Interaction((int)(Mathf::unitRandom()*200),(int)(Mathf::unitRandom()*200)));
//		ihm2->insert(interaction);
//		cout << "inserted interaction Hash Map 2   : " << interaction->getId1() << " " << interaction->getId2() << endl;
//	}
//////////////////////////////////////////
//////////////////////////////////////////
//////////////////////////////////////////

}


void Root::registerAttributes()
{
//	 FIXME vector<string>
/////////////////////////////////////

	REGISTER_ATTRIBUTE(v2);
	REGISTER_ATTRIBUTE(v3);
	REGISTER_ATTRIBUTE(v4);
	REGISTER_ATTRIBUTE(m2);
	REGISTER_ATTRIBUTE(m3);
	REGISTER_ATTRIBUTE(m4);
	REGISTER_ATTRIBUTE(q);
	REGISTER_ATTRIBUTE(se3);

	REGISTER_ATTRIBUTE(i);		// int
	REGISTER_ATTRIBUTE(f);		// float
	REGISTER_ATTRIBUTE(d);		// double
	REGISTER_ATTRIBUTE(c);		// char
	REGISTER_ATTRIBUTE(ul);		// unsigned long
	REGISTER_ATTRIBUTE(s);
	REGISTER_ATTRIBUTE(bo);		// boolean

	REGISTER_ATTRIBUTE(ptr_v_i);	// pointer of vector of fundamental
	REGISTER_ATTRIBUTE(ptr_ac_ac);
	REGISTER_ATTRIBUTE(ptr_a_ac);
	REGISTER_ATTRIBUTE(ptr_a_acd);
	REGISTER_ATTRIBUTE(v_ptr_a);

	REGISTER_ATTRIBUTE(va);		// 					vector<A>
	REGISTER_ATTRIBUTE(vi);		// 					vector<int>
	REGISTER_ATTRIBUTE(vvi);	// 					vector<vector<int>>
	REGISTER_ATTRIBUTE(vvvi);	// 					vector<vector<vector<int>>>
	REGISTER_ATTRIBUTE(vv3);	// 					vector< vector3 >

	REGISTER_ATTRIBUTE(ac);
	REGISTER_ATTRIBUTE(a);		// 					Serializable class
	REGISTER_ATTRIBUTE(ac2);
	REGISTER_ATTRIBUTE(dynA);
	REGISTER_ATTRIBUTE(vdynA);
	REGISTER_ATTRIBUTE(si);

	REGISTER_ATTRIBUTE(b);		// works				Non Serializable class
	REGISTER_ATTRIBUTE(vb);		// why it works??			vector <B>
	REGISTER_ATTRIBUTE(vvb);	// AND THIS?				vector< vector <B> >


	REGISTER_ATTRIBUTE(small_pair);
	REGISTER_ATTRIBUTE(pair_int_A);
	REGISTER_ATTRIBUTE(pair_B_longdouble);
	REGISTER_ATTRIBUTE(pair_B_A);
	REGISTER_ATTRIBUTE(pair_B_pA);

	REGISTER_ATTRIBUTE(pair_pA_vdynA);
	REGISTER_ATTRIBUTE(pair_pA_vvvi);

	REGISTER_ATTRIBUTE(v_pair_int_pA);

	REGISTER_ATTRIBUTE(tuple_int);
	REGISTER_ATTRIBUTE(tuple_B);
	REGISTER_ATTRIBUTE(tuple_pA);

	REGISTER_ATTRIBUTE(tuple_pA_vdynA);
 	REGISTER_ATTRIBUTE(tuple_pA_vvvi);

	REGISTER_ATTRIBUTE(tuple_int_pA_int);
	REGISTER_ATTRIBUTE(tuple_funds);

	REGISTER_ATTRIBUTE(bodies);
	REGISTER_ATTRIBUTE(bodies2);
	REGISTER_ATTRIBUTE(li);
	REGISTER_ATTRIBUTE(lf);


	REGISTER_ATTRIBUTE(ivs);
	REGISTER_ATTRIBUTE(ihm);


/////////////////////////////////////

// FIXME : pointers to Vector3, and pointers to custom class are not working.

/////////////////////////////////////

//	REGISTER_ATTRIBUTE(vpppi);		// vector of pointer of pointer of pointer of fundamental
//	REGISTER_ATTRIBUTE(pppi);
//	REGISTER_ATTRIBUTE(ptr_ptr_i);		// pointer of pointer of fundamental
//	REGISTER_ATTRIBUTE(vpi);		// vector of pointer of fundamental
//	REGISTER_ATTRIBUTE(ptr_i);		// pointer to fundamental
//	REGISTER_ATTRIBUTE(vpb);		// FIXME
//	REGISTER_ATTRIBUTE(ptr_v3);		// FIXME
//	REGISTER_ATTRIBUTE(vpv3);		// FIXME
//	REGISTER_ATTRIBUTE(ptr_ptr_v3);		// FIXME
//	REGISTER_ATTRIBUTE(ptr_v_v3);		// FIXME
// 	REGISTER_ATTRIBUTE(tuple_check); 	// FIXME
//	REGISTER_ATTRIBUTE(tuple_int_pA_pB_B);	// FIXME
//	REGISTER_ATTRIBUTE(ptr_b);		// FIXME
//	REGISTER_ATTRIBUTE(ptr_b_bc);		// pointer of custom class
//	REGISTER_ATTRIBUTE(ptr_bc);		// BAD  - pointer to BC, not B

/////////////////////////////////////
}

