#ifndef __ROOT__
#define __ROOT__

#include "Serializable.hpp"
#include "A.hpp"
#include "AC.hpp"
#include "ACD.hpp"
#include "B.hpp"


#include "Vector2.hpp"
#include "Vector3.hpp"
#include "Vector4.hpp"
#include "Matrix2.hpp"
#include "Matrix3.hpp"
#include "Matrix4.hpp"
#include "Quaternion.hpp"
#include "Se3.hpp"
#include "InteractionContainer.hpp"
#include "InteractionVecSet.hpp"
#include "InteractionHashMap.hpp"


#include <list>
#include <set>
#include <deque>
#include <boost/tuple/tuple.hpp>
#include "AssocVector.hpp"

class Root : public Serializable
{

	private : Vector2r v2;
	private : Vector3r v3;
	private : Vector4r v4;
	private : Matrix2r m2;
	private : Matrix3r m3;
	private : Matrix4r m4;
	private : Quaternionr q;
	private : Se3r se3;


	// FUNDAMENTAL SINGLE
	public : int i;
	private : float f;
	private : double d;
	private : char c;
	private : unsigned long ul;

	private : bool bo;
	private : string s;
	private : A a;
	private : B b;
	private : std::deque<A> va;
	private : std::deque<B> vb;
	private : std::deque< deque <B> > vvb;
	private : std::deque<int> vi;
	private : std::set<int> si;
	private : std::deque<Vector3r> vv3;


	private : std::deque<set<int> > vvi;
//	private : std::deque<deque<int> > vvi;
	private : std::deque<deque<set<int> > > vvvi;
//	private : std::deque<deque<deque<int> > > vvvi;

	private : AC ac,ac2;

	private : shared_ptr<AC> ptr_ac_ac;
	private : shared_ptr<A> ptr_a_ac;
	private : shared_ptr<A> ptr_a_acd;
	private : deque<shared_ptr<A> > v_ptr_a;

	private : shared_ptr<B> ptr_b;
	private : shared_ptr<BC> ptr_bc;
	private : shared_ptr<B> ptr_b_bc;


	private : shared_ptr<int> ptr_i;
	private : shared_ptr<Vector3r> ptr_v3;
	private : shared_ptr<shared_ptr<int> > ptr_ptr_i;
	private : shared_ptr<shared_ptr<shared_ptr<int> > > pppi;
	private : shared_ptr<shared_ptr<Vector3r> > ptr_ptr_v3;

	private : shared_ptr<deque<Vector3r> > ptr_v_v3;
	private : shared_ptr<deque<int> > ptr_v_i;

	private : std::deque<shared_ptr<Vector3r> > vpv3;
	private : std::deque<shared_ptr<B> > vpb;

	private : shared_ptr<A> dynA;
	private : deque<shared_ptr<A> > vdynA;

	private : list<int> li;
	//private : list<list<list<int> > > li;
	private : list<float> lf;
	private : std::deque<shared_ptr<int> > vpi;
	private : std::deque<shared_ptr<shared_ptr<shared_ptr<int> > > > vpppi;


	private : std::pair<int,long double> small_pair;
	private : std::pair<int, A > pair_int_A;
	private : std::pair< B, long double > pair_B_longdouble;
	private : std::pair< B, A > pair_B_A;
	private : std::pair< B, shared_ptr<A> > pair_B_pA;

	private : std::pair< shared_ptr<A> , deque<shared_ptr<A> > > pair_pA_vdynA;
	private : std::pair< shared_ptr<A> , deque<deque<set<int> > > > pair_pA_vvvi;

	private : std::deque< pair< int, shared_ptr<A> > > v_pair_int_pA;


	private : boost::tuple< int > tuple_int;
	private : boost::tuple< B > tuple_B;
	private : boost::tuple< shared_ptr<A> > tuple_pA;

	private : boost::tuple< shared_ptr<A> , deque<shared_ptr<A> > > tuple_pA_vdynA; // 2
	private : boost::tuple< shared_ptr<A> , deque<deque<set<int> > > > tuple_pA_vvvi; // 2
	private : boost::tuple< int , shared_ptr<A> , int > tuple_int_pA_int; // 3
	private : boost::tuple< int , shared_ptr<A> , shared_ptr<B> , B > tuple_int_pA_pB_B; //4
	private : boost::tuple< int , long , float , long double , bool > tuple_funds; // 5
	private : boost::tuple< int , long , float , shared_ptr<B> , bool > tuple_check; // 5


	private : map<int, shared_ptr<A> > bodies;
	private : Loki::AssocVector<int, shared_ptr<A> > bodies2;

  	private : shared_ptr<InteractionContainer> ivs;
	private : shared_ptr<InteractionContainer> ihm;
//	private : shared_ptr<InteractionContainer> ihm2;

	public  : Root();

	public  : virtual ~Root();

	public : virtual void registerAttributes();
	public : void init();

	REGISTER_CLASS_NAME(Root);
};


REGISTER_SERIALIZABLE(Root,false);

#endif // __ROOT__
